<?php
declare (strict_types = 1);

namespace app\admin\model\v1;

use app\common\model\SysConfigBaseModel;
use think\model\concern\SoftDelete;

/**
 * 系统配置模型
 * @mixin \think\Model
 */
class SysConfigModel extends SysConfigBaseModel
{
    // 启用软删除
    use SoftDelete;
    // 软删除字段
    protected $deleteTime = 'deleted_at';

    // 关联分组
    public function group()
    {
        return $this->belongsTo('SysConfigGroupModel', 'group_id', 'id');
    }

    // 关联类型
    public function type()
    {
        return $this->belongsTo('SysConfigTypeModel', 'type', 'value');
    }

    // 按title搜索
    public function searchTitleAttr($query, $value, $data)
    {
        if (empty($value)) {
            return;
        }
        $query->where('title', 'like', "%{$value}%");
    }

    // 按group_id查询
    public function scopeGroupId($query, $value)
    {
        if (is_array($value)) {
            $query->where('group_id', 'in', $value);
            return;
        }
        $query->where('group_id', '=', $value);
    }

    // 按name查询
    public function scopeByName($query, $value)
    {
        if (is_array($value)) {
            $query->where('name', 'in', $value);
            return;
        }
        $query->where('name', '=', $value);
    }
}
